local AnnounceZone = nil
local lastTargetID = nil
local UpdateInterval = 1.0
local raresInfo =
{
    ["Mechagon"] =
    {
        {151934, "Arachnoid Harvester",        1, nil, true, 55512, true, 55512, {0, 0}, {{52, 42}}, {} },
        {150394, "Armored Vaultbot",           1, nil, true, 55546, true, 55546, {0, 0}, {{52, 45}}, {} },
        {153200, "Boilburn",                   1, nil, true, 55857, true, 55857, {0, 0}, {{51, 50}}, {} },
        {151308, "Boggac Skullbash",           1, nil, true, 55539, true, 55539, {0, 0}, {{54, 30}}, {} },
        {152001, "Bonepicker",                 1, nil, true, 55537, true, 55537, {0, 0}, {{65, 25}}, {} },
        {154739, "Caustic Mechaslime",         1, nil, true, 56368, true, 56368, {0, 0}, {{66, 58}}, {} }, 
        {149847, "Crazed Trogg",               1, nil, true, 55812, true, 55812, {0, 0}, {{82, 21}}, {} },
        {151569, "Deepwater Maw",              1, nil, true, 55514, true, 55514, {0, 0}, {{35, 43}}, {} },
        {150342, "Earthbreaker Gulroc",        1, nil, true, 55814, true, 55814, {0, 0}, {{63, 25}}, {} },
        {154153, "Enforcer KX-T57",            1, nil, true, 56207, true, 56207, {0, 0}, {{53, 63}}, {} },
        {151202, "Foul Manifestation",         1, nil, true, 55513, true, 55513, {0, 0}, {{65, 51}}, {} },
        {151884, "Fungarian Furor",            1, nil, true, 55367, true, 55367, {0, 0}, {{48, 47}}, {} },
        {153228, "Gear Checker Cogstar",       1, nil, true, 55852, true, 55852, {0, 0}, {{"??", "??"}}, {} },
        {153205, "Gemicide",                   1, nil, true, 55855, true, 55855, {0, 0}, {{59, 67}}, {} },
        {154701, "Gorged Gear-Cruncher",       1, nil, true, 56367, true, 56367, {0, 0}, {{72, 54}}, {} },
        {151684, "Jawbreaker",                 1, nil, true, 55399, true, 55399, {0, 0}, {{75, 43}}, {} },
        {152007, "Killsaw",                    1, nil, true, 55369, true, 55369, {0, 0}, {{41, 34}}, {} },
        {151933, "Malfunctioning Beastbot",    1, nil, true, 55544, true, 55544, {0, 0}, {{61, 41}}, {} },
        {151124, "Mechagonian Nullifier",      1, nil, true, 55207, true, 55207, {0, 0}, {{57, 52}}, {} },
        {151672, "Mecharantula",               1, nil, true, 55386, true, 55386, {0, 0}, {{88, 18}}, {} },
        {151627, "Mr. Fixthis",                1, nil, true, 55859, true, 55859, {0, 0}, {{60, 62}}, {} },
        {151296, "OOX-Avenger/MG",             1, nil, true, nil,   true, nil,   {0, 0}, {{57, 39}}, {} },
        {153206, "Ol' Big Tusk",               1, nil, true, 55853, true, 55853, {0, 0}, {{56, 16}}, {} },
        {152764, "Oxidized Leachbeast",        1, nil, true, 55856, true, 55856, {0, 0}, {{56, 60}}, {} },
        {151702, "Paol Pondwader",             1, nil, true, 55405, true, 55405, {0, 0}, {{22, 68}}, {} },
        {150575, "Rumblerocks",                1, nil, true, 55368, true, 55368, {0, 0}, {{39, 53}}, {} },
        {152182, "Rustfeather",                1, nil, true, 55811, true, 55811, {30, 60}, {{66, 78}}, {} },
        {155583, "Scrapclaw",                  1, nil, true, 56737, true, 56737, {0, 0}, {{82, 78}}, {} },
        {150937, "Seaspit",                    1, nil, true, 55545, true, 55545, {0, 0}, {{20, 79}}, {} },
        {153000, "Sparkqueen P'Emp",           1, nil, true, nil,   true, nil,   {0, 0}, {{78, 31}}, {} },
        {153226, "Steel Singer Freza",         1, nil, true, 55854, true, 55854, {0, 0}, {{25, 77}}, {} },
        {155060, "The Doppel Gang",            1, nil, true, nil,   true, nil,   {0, 0}, {{80, 20}}, {} },
        {152113, "The Kleptoboss",             1, nil, true, 55858, true, 55858, {0, 0}, {{68, 48}}, {} },
        {154225, "The Rusty Prince",           1, nil, true, 56182, true, 56182, {0, 0}, {{57, 58}}, {} },
        {151625, "The Scrap King",             1, nil, true, 55364, true, 55364, {0, 0}, {{71, 49}}, {} },
        {151940, "Uncle T'Rog",                1, nil, true, 55538, true, 55538, {0, 0}, {{57, 21}}, {} },
    },
    ["Nazjatar"] =
    {
        {152415, "Alga the Eyeless",           1, nil, true, nil,   true, nil,   {0, 0}, {{53, 44}}, {} },
        {152416, "Allseer Oma'kil",            1, nil, true, nil,   true, nil,   {0, 0}, {{68, 38}}, {} },
        {153306, "Azsh'ari Leviathan",         1, nil, true, 56830, true, 56830, {180, 180}, {{58, 29}}, {} },
        {152794, "Amethyst Spireshell",        1, nil, true, 56268, true, 56268, {0, 0}, {{"??", "??"}}, {} },
        {152566, "Anemonar",                   1, nil, true, 56281, true, 56281, {30, 60}, {{59, 54}}, {} },
        {150191, "Avarius",                    1, nil, true, 55584, true, 55584, {0, 0}, {{37, 12}}, {} },
        {152712, "Blindlight",                 1, nil, true, 56269, true, 56269, {0, 0}, {{37, 82}}, {} }, 
        {149653, "Carnivorous Lasher",         1, nil, true, 55366, true, 55366, {0, 0}, {{55, 42}}, {} }, 
        {152464, "Caverndark Terror",          1, nil, true, 56283, true, 56283, {0, 0}, {{42, 13}}, {} },
        {152556, "Chasm-Haunter",              1, nil, true, nil,   true, nil,   {0, 0}, {{50, 88}}, {} },
        {155811, "Commander Minzera",          1, nil, true, 56882, true, 56882, {180, 180}, {{34, 31}}, {} },
        {152756, "Daggertooth Terror",         1, nil, true, 56271, true, 56271, {0, 0}, {{"??", "??"}}, {} },
        {152291, "Deepglider",                 1, nil, true, nil,   true, nil,   {0, 0}, {{"??", "??"}}, {} },
        {152555, "Elderspawn Nalaada",         1, nil, true, 56285, true, 56285, {0, 0}, {{52, 76}}, {} },
        {152414, "Elder Unu",                  1, nil, true, 56284, true, 56284, {0, 0}, {{66, 35}}, {} },
        {152553, "Garnetscale",                1, nil, true, 56273, true, 56273, {0, 0}, {{39, 43}}, {} },
        {155838, "Incantatrix Vazina",         1, nil, true, 56895, true, 56895, {180, 180}, {{79, 51}}, {} },
        {152448, "Iridescent Glimmershell",    1, nil, true, 56286, true, 56286, {0, 0}, {{"??", "??"}}, {} },
        {152567, "Kelpwillow",                 1, nil, true, 56287, true, 56287, {30, 60}, {{51, 71}}, {} },
        {152323, "King Gakula",                1, nil, true, 55671, true, 55671, {0, 0}, {{29, 29}}, {} },
        {144644, "Mirecrawler",                1, nil, true, 56274, true, 56274, {0, 0}, {{"??", "??"}}, {} },
        {152465, "Needlespine",                1, nil, true, 56275, true, 56275, {0, 0}, {{"??", "??"}}, {} },
        {152397, "Oronu",                      1, nil, true, 56288, true, 56288, {30, 60}, {{79, 26}}, {} },
        {152681, "Prince Typhonus",            1, nil, true, 56289, true, 56289, {0, 0}, {{43, 87}}, {} },
        {152682, "Prince Vortran",             1, nil, true, 56290, true, 56290, {0, 0}, {{43, 74}}, {} },
        {150583, "Rockweed Shambler",          1, nil, true, 56291, true, 56291, {0, 0}, {{"??", "??"}}, {} },
        {151870, "Sandcastle",                 1, nil, true, 56276, true, 56276, {0, 0}, {{"??", "??"}}, {} },
        {152795, "Sandclaw Stoneshell",        1, nil, true, 56277, true, 56277, {0, 0}, {{"??", "??"}}, {} },
        {155841, "Shadowbinder Athissa",       1, nil, true, 56894, true, 56894, {180, 180}, {{74, 31}}, {} },
        {152548, "Scale Matriarch Gratinax",   1, nil, true, 56292, true, 56292, {0, 0}, {{36, 42}}, {} },
        {152545, "Scale Matriarch Vynara",     1, nil, true, 56293, true, 56293, {0, 0}, {{28, 37}}, {} },
        {152542, "Scale Matriarch Zodia",      1, nil, true, 56294, true, 56294, {0, 0}, {{29, 46}}, {} },
        {152552, "Shassera",                   1, nil, true, 56295, true, 56295, {0, 0}, {{65, 08}}, {} },
        {153658, "Shiz'narasz the Consumer",   1, nil, true, nil,   true, nil,   {0, 0}, {{41, 16}}, {} },
        {152359, "Siltstalker the Packmother", 1, nil, true, 56297, true, 56297, {0, 0}, {{72, 55}}, {} },
        {152290, "Soundless",                  1, nil, true, 56298, true, 56298, {0, 0}, {{"??", "??"}}, {} },
        {155836, "Theurgist Nitara",           1, nil, true, 56890, true, 56890, {180, 180}, {{49, 66}}, {} },
        {153898, "Tidelord Aquatus",           1, nil, true, nil,   true, nil,   {0, 0}, {{63, 30}}, {} },
        {153928, "Tidelord Dispersius",        1, nil, true, nil,   true, nil,   {0, 0}, {{59, 27}}, {} },
        {154148, "Tidemistress Leth'sindra",   1, nil, true, 56106, true, 56106, {0, 0}, {{66, 24}}, {} },
        {152360, "Toxigore the Alpha",         1, nil, true, 56278, true, 56278, {0, 0}, {{67, 47}}, {} },
        {152568, "Urduu",                      1, nil, true, nil,   true, nil,   {30, 60}, {{32, 31}}, {} },
        {152568, "Voice in the Deeps",         1, nil, true, nil,   true, nil,   {0, 0}, {{68, 35}}, {} },
        {150468, "Vor'koth",                   1, nil, true, 55603, true, 55603, {0, 0}, {{48, 24}}, {} },
        {155840, "Warlord Zalzjar",            1, nil, true, 56893, true, 56893, {180, 180}, {{48, 32}}, {} }
    }
}

local addon = LibStub("AceAddon-3.0"):NewAddon("RareUtil", "AceConsole-3.0")
local RareUtilLDB = LibStub("LibDataBroker-1.1"):NewDataObject("RareUtil", {
	type = "data source",
	text = "RareUtil",
	icon = "Interface\\Icons\\Inv_darkmoon_eye",
	OnClick = function() if RareUtilAddonFrame:IsShown() then RareUtilAddonFrame:Hide() elseif not RareUtilAddonFrame:IsShown() then RareUtilAddonFrame:Show() end end
})
local icon = LibStub("LibDBIcon-1.0")

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RareUtilDB", {
		profile = {
			minimap = {
				hide = false,
			},
		},
	})
	icon:Register("RareUtil", RareUtilLDB, self.db.profile.minimap)
	self:RegisterChatCommand("RareUtil", "RareUtilMiniMapIconClick")
end

function addon:RareUtilMiniMapIconClick()
	self.db.profile.minimap.hide = not self.db.profile.minimap.hide
	if self.db.profile.minimap.hide then
		icon:Hide("RareUtil")
	else
		icon:Show("RareUtil")
	end
end

function RareUtil_OnLoad(self)
    local RareUtilAddonFrame = CreateFrame("FRAME", "RareUtilAddonFrame", UIParent)
    RareUtilAddonFrame:SetSize(250, 300)
    RareUtilAddonFrame:SetPoint("CENTER", 0, 0)
    RareUtilAddonFrame.texture = RareUtilAddonFrame:CreateTexture()
    RareUtilAddonFrame.texture:SetAllPoints(true)
    
    RareUtilAddonFrame:EnableMouse(true)
    RareUtilAddonFrame:SetMovable(true)
    RareUtilAddonFrame:SetScript("OnEvent", RareUtil__EventHandler)
    RareUtilAddonFrame:RegisterForDrag("LeftButton")
    RareUtilAddonFrame:SetScript("OnDragStart", RareUtilAddonFrame.StartMoving)
    RareUtilAddonFrame:SetScript("OnDragStop", RareUtilAddonFrame.StopMovingOrSizing)
    RareUtilAddonFrame:SetScript("OnUpdate", RareUtil_OnUpdate)
    RareUtilAddonFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
    RareUtilAddonFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
    RareUtilAddonFrame:RegisterEvent("ADDON_LOADED");
    RareUtilAddonFrame.TimeSinceLastUpdate = 0

    local AddonTitle = RareUtilAddonFrame:CreateFontString("AddonTitle", "ARTWORK", "GameFontNormal")
    AddonTitle:SetText("AzerPUG RareUtility")
    AddonTitle:SetWidth("100")
    AddonTitle:SetHeight("10")
    AddonTitle:SetPoint("TOP", "RareUtilAddonFrame", -55, -3)

    local ZoneSubHeader = RareUtilAddonFrame:CreateFontString("ZoneSubHeader", "ARTWORK", "GameFontNormalSmall")
    ZoneSubHeader:SetText(" - UNSPECIFIED - ")
    ZoneSubHeader:SetWidth("100")
    ZoneSubHeader:SetHeight("10")
    ZoneSubHeader:SetPoint("TOP", "RareUtilAddonFrame", -55, -15) 

    zone = GetZoneText()
    ZoneSubHeader:SetText(zone)

    local OptionsPanel = CreateFrame("FRAME", "AzerPUG RareUtility")
    OptionsPanel.name = "AzerPUG RareUtility"
    InterfaceOptions_AddCategory(OptionsPanel)

    local OptionsHeader = OptionsPanel:CreateFontString("OptionsHeader", "ARTWORK", "GameFontNormalHuge")
    OptionsHeader:SetText("AzerPUG RareUtility - Options")
    OptionsHeader:SetWidth(OptionsPanel:GetWidth())
    OptionsHeader:SetHeight(OptionsPanel:GetHeight())
    OptionsHeader:SetPoint("TOP", 0, -10) 

    local AutomaticOptionsCheckButton = CreateFrame("CheckButton", "AutomaticOptionsCheckButton", OptionsPanel, "ChatConfigCheckButtonTemplate")
    AutomaticOptionsCheckButton:SetPoint("TOPLEFT", 25, -50)
    AutomaticOptionsCheckButtonText:SetText(" Automatic Mode")
    AutomaticOptionsCheckButton.tooltip = "Automatic Announcement Function"
    AutomaticOptionsCheckButton:SetScript("OnClick",
    function()
        if AutomaticOptionsCheckButton:GetChecked() == true then
            RareUtil_EnableAuto()
        elseif AutomaticOptionsCheckButton:GetChecked() == false then
            RareUtil_DisableAuto()
        end
    end);

    local RareUtilityAnnounceButton = CreateFrame("Button", "RareUtilityAnnounceButton", RareUtilAddonFrame, "UIPanelButtonTemplate")
    RareUtilityAnnounceButton.contentText = RareUtilityAnnounceButton:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
    RareUtilityAnnounceButton.contentText:SetText("Announce Rare")
    RareUtilityAnnounceButton:SetWidth("100")
    RareUtilityAnnounceButton:SetHeight("25")
    RareUtilityAnnounceButton.contentText:SetWidth("100")
    RareUtilityAnnounceButton.contentText:SetHeight("15")
    RareUtilityAnnounceButton:SetPoint("TOP", 55, -5)
    RareUtilityAnnounceButton.contentText:SetPoint("CENTER", 0, -1)
    RareUtilityAnnounceButton:SetScript("OnClick", function() RareUtil_CheckRareMob() end )

    for zone, rares in pairs(raresInfo) do
        RareUtil_CreateUnitButtons(zone)
    end

    RareUtil_ShowButtons(zone)
end

function RareUtil_CreateUnitButtons(zone)
    for i = 1, #raresInfo[zone] do
        local raresZI = raresInfo[zone][i]
        raresZI[4] = CreateFrame("Button", nil, RareUtilAddonFrame)
        raresZI[4].contentText = raresZI[4]:CreateFontString(nil, "ARTWORK", "GameFontNormal")
        raresZI[4].contentText:SetText(raresZI[2])
        raresZI[4]:SetWidth("104")
        raresZI[4]:SetHeight("10")
        raresZI[4].contentText:SetWidth("104")
        raresZI[4].contentText:SetHeight("10")
        if i <= math.ceil(#raresInfo[zone] / 2) then
            raresZI[4]:SetPoint("TOP", -52, (-11 * i - 30))
            raresZI[4].contentText:SetPoint("TOP", 0, 0)
        else
            raresZI[4]:SetPoint("TOP", 52, (-11 * (i-math.ceil(#raresInfo[zone] / 2)) -30))
            raresZI[4].contentText:SetPoint("TOP", 0, 0)
        end
        local xLocation = raresZI[10][1][1]
        local yLocation = raresZI[10][1][2]
        local name = raresZI[2]
        raresZI[4]:SetScript("OnClick", function(i) 
            if xLocation == "??" or yLocation == "??" then
                print("Rare has more then one spawn location, implementation coming soon!")
            else
                TomTom:AddWaypointToCurrentZone(xLocation, yLocation, name) 
            end
        end)
        if raresZI[6] ~= nil then
            if IsQuestFlaggedCompleted(raresZI[6]) then
                raresZI[4].contentText:SetTextColor(0, 1, 0, 1.0)
            else
                raresZI[4].contentText:SetTextColor(1, 0, 0, 1.0)
            end
        else
            raresZI[4].contentText:SetTextColor(0, 0, 0, 1.0)
        end
    end
end

function RareUtil_SavedVarsLoad()
    if RareUtil_AutomaticAnnounce == true then
        AutomaticOptionsCheckButton:SetChecked(true)
    else
        AutomaticOptionsCheckButton:SetChecked(false)
    end
    RareUtilAddonFrame.texture:SetColorTexture(0.5, 0.5, 0.5, 0.5)
end

function RareUtil__EventHandler(self, event, ...)
    if event == "ADDON_LOADED" then
        RareUtil_SavedVarsLoad()
    elseif event == "ZONE_CHANGED_NEW_AREA" then
        RareUtil_ShowButtons(GetZoneText())
    elseif event == "PLAYER_TARGET_CHANGED" then
        local zone =  GetZoneText()
        for iterationZone, rares in pairs(raresInfo) do
            if zone == iterationZone then
                for i = 1, #rares do
                    if lastTargetID == rares[i][1] then
                        if rares[i][6] ~= nil then
                            if IsQuestFlaggedCompleted(rares[i][6]) then
                                rares[i][4].contentText:SetTextColor(0, 1, 0, 1.0)
                            end
                        end
                    elseif lastTargetID == 152569 or lastTargetID == 152570 then
                        if IsQuestFlaggedCompleted(55812) then
                            rares[7][4].contentText:SetTextColor(0, 1, 0, 1.0)
                        end
                    elseif lastTargetID == 154342 then
                        if IsQuestFlaggedCompleted(55512) then
                            rares[1][4].contentText:SetTextColor(0, 1, 0, 1.0)
                        end
                    elseif lastTargetID == 154968 then
                        if IsQuestFlaggedCompleted(55812) then
                            rares[2][4].contentText:SetTextColor(0, 1, 0, 1.0)
                        end
                    end
                end
                if RareUtil_AutomaticAnnounce == true then
                    RareUtil_CheckRareMob()
                end
            end
        end
    end
end

function RareUtil_ShowButtons(zone)
    ZoneSubHeader:SetText(zone)
    for selectedZone, rares in pairs(raresInfo) do
        for i = 1, #rares do
            if zone == selectedZone then
                rares[i][4]:Show()
            else
                rares[i][4]:Hide()
            end
        end
    end
end

function RareUtil_CheckGeneralChat()
    local channelName = EnumerateServerChannels()
    local zone = GetZoneText()
    local channelID = GetChannelName(channelName .. " - " .. zone)
    return channelID
end

function RareUtil_CheckRareMob()
    if UnitExists("Target") then
        local name = UnitName("target")
        local coords = RareUtil_GetPlayerCoords()
        local unitHealth = RareUtil_GetTargetHealth()
        local zone = GetZoneText()
        local UnitID = RareUtil_GetTargetUnitID()

        for i = 1, #raresInfo[zone] do
            if UnitID == raresInfo[zone][i][1] then
                if RareUtil_AutomaticAnnounce == false then
                    RareUtil_AnnounceRare(name, coords, unitHealth)
                    raresInfo[zone][i][3] = time()
                else
                    if raresInfo[zone][i][3] < (time() - 300) then
                        RareUtil_AnnounceRare(name, coords, unitHealth)
                        raresInfo[zone][i][3] = time()
                    end
                end
            end
        end

        if name == "Murloco" then
            RareUtil_AnnounceMurloco()
        end

        if name == "RAG-TAG" then
            RareUtil_AnnounceArmory(coords)
        end
        lastTargetID = UnitID
    else
        lastTargetID = nil
    end
end

function RareUtil_AnnounceRare(name, coords, unitHealth)
    local promo = "AzerPUG RareUtility"
    local dash = " - "
    local percent = "%"
    local life = " life."
    local announceChannel = RareUtil_CheckGeneralChat()

    if unitHealth <= 0 then
        SendChatMessage((name .. " dead!"  .. dash .. promo), "CHANNEL", nil, announceChannel)
    elseif unitHealth == 100 then
        SendChatMessage((name .. dash .. coords .. dash .. "Unengaged!" .. dash .. promo), "CHANNEL", nil, announceChannel)
    elseif unitHealth > 5 then
        SendChatMessage((name .. dash .. coords .. dash .. unitHealth .. percent .. life .. dash .. promo), "CHANNEL", nil, announceChannel)
    end
end 

function RareUtil_AnnounceArmory(coords)
    local promo = "AzerPUG RareUtility"
    local dash = " - "
    SendChatMessage(("Completed Armory" .. dash .. coords .. dash .. promo), "CHANNEL", nil, announceChannel)
end

function RareUtil_AnnounceDrillRig(UnitID)
    local promo = "AzerPUG RareUtility"
    local dash = " - "
end

function RareUtil_AnnounceMurloco()
    local promo = "AzerPUG RareUtility"
    local dash = " - "
    SendChatMessage(("Murloco found!" .. dash .. "46 32" .. dash .. promo), "CHANNEL", nil, announceChannel)
end

function RareUtil_GetPlayerCoords()
    loc = C_Map.GetBestMapForUnit("player")
    local pos = C_Map.GetPlayerMapPosition(loc, "player")
    local coords = math.ceil(pos.x * 10000)/100 .. " " .. math.ceil(pos.y * 10000)/100

    return coords
end

function RareUtil_GetTargetUnitID()
    if UnitExists("Target") then
        local v1, v2, v3, v4, v5, v6 = strsplit("-", UnitGUID("target"))
        return tonumber(v6)
    end
end

function RareUtil_GetTargetHealth()
    local currentHealth = UnitHealth("target")
    local maxHealth = UnitHealthMax("target")
    local healthPercentage = math.floor(currentHealth / maxHealth * 100)
    return healthPercentage
end

function RareUtil_EnableAuto()
    RareUtil_AutomaticAnnounce = true
    AutomaticOptionsCheckButton:SetChecked(true)
    ChatFrame1:AddMessage("Automatic Mode is Enabled!")
end

function RareUtil_DisableAuto()
    RareUtil_AutomaticAnnounce = false
    AutomaticOptionsCheckButton:SetChecked(false)
    ChatFrame1:AddMessage("Automatic Mode is Disabled!")
end

SLASH_RAREUTIL1 = "/rareutil"
SlashCmdList["RAREUTIL"] = function(msg, editbox)
    if string.find(msg, "hide") then
        RareUtilAddonFrame:Hide()
    elseif string.find(msg, "show") then
        RareUtilAddonFrame:Show()
    elseif string.find(msg, "auto") then
        RareUtil_EnableAuto()
    elseif string.find(msg, "manual") then
        RareUtil_DisableAuto()
    elseif string.find(msg, "options") then
        InterfaceOptionsFrame_OpenToCategory("AzerPUG RareUtility");
        InterfaceOptionsFrame_OpenToCategory("AzerPUG RareUtility");
    elseif string.find(msg, "help") then
        ChatFrame1:AddMessage("/rareutil help;      display this message")
        ChatFrame1:AddMessage("/rareutil options;   opens the options panel")
        ChatFrame1:AddMessage("/rareutil hide;      hides the Addon Frame")
        ChatFrame1:AddMessage("/rareutil show;      shows the Addon Frame")
        ChatFrame1:AddMessage("/rareutil auto;      automatic announcements (also hides announce button).")
        ChatFrame1:AddMessage("/rareutil manual;    manual announcements (also shows announce button).")
    end
end

RareUtil_OnLoad(self)